package com.common.commonlib.image.loader

import android.graphics.drawable.Drawable
import com.bumptech.glide.RequestBuilder
import com.common.commonlib.image.config.GlideHolderConfig

/**
 * 全局配置适配器
 */
object GlobalConfigHelper {
    var globalHolderConfig: GlideHolderConfig? = null

    fun loadWithGlobalConfig(requestBuilder: RequestBuilder<Drawable>): RequestBuilder<Drawable> {
        return loadWithGlobalConfig(requestBuilder, globalHolderConfig)
    }

    fun loadWithGlobalConfig(
        requestBuilder: RequestBuilder<Drawable>,
        holderConfig: GlideHolderConfig?
    ): RequestBuilder<Drawable> {
        var request = requestBuilder
        if (holderConfig != null) {
            if (holderConfig.holderDrawable != null) {
                request = request.placeholder(holderConfig.holderDrawable)
            }
            if (holderConfig.holderId != -1) {
                request = request.placeholder(holderConfig.holderId)
            }
            if (holderConfig.errorDrawable != null) {
                request = request.error(holderConfig.errorDrawable)
            }
            if (holderConfig.errorId != -1) {
                request = request.error(holderConfig.errorId)
            }
            if (holderConfig.errorBuilder != null) {
                request = request.error(holderConfig.errorBuilder)
            }
            if (holderConfig.fallBackDrawable != null) {
                request = request.fallback(holderConfig.fallBackDrawable)
            }
            if (holderConfig.fallBackId != -1) {
                request = request.fallback(holderConfig.fallBackId)
            }
        }
        return request
    }
}